<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js"
        integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"
        integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
        crossorigin="anonymous"></script>
    <title>Task 30.10</title>
</head>

<body>
    <div class="container jumbotron">
        <form id="loginForm">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="input-email" aria-describedby="emailHelp"
                    placeholder="Enter Email" name="email">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="input-password" placeholder="Password" name="password">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
    <script>
        'use strict';
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
        var gLoginForm = document.getElementById("loginForm");
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Xử lý sự kiện on submit của thẻ form bằng cách lập trình lại.       
        gLoginForm.addEventListener("submit", (e) => {
            // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
            e.preventDefault();
            // Tiếp theo thực hiện 4 bước để gọi api login
            console.log("Đang đợi bạn lập trình tiếp");
            onBtnLoginClick();
        });

        // Xử lý sự kiện khi bấm nút Login:
        function onBtnLoginClick() {
            "use strict";
            //base url

            // 4 bước xử lý có kết nối API: 1. Lấy dữ liệu, 2. kiểm tra dữ liệu, nếu dữ liệu hợp lệ thì 3. gọi API và 4.xử lý kết quả trả về

            var vFormData = {
                email: "",
                password: ""
            }
            // B1. Gọi hàm lấy dữ liệu
            layDuLieu(vFormData);

            // B2. Gọi hàm kiểm tra dữ liệu
            var vKiemTraDuLieu = kiemTraDuLieu (vFormData);
            if (vKiemTraDuLieu == true){
                // B3. Gọi API
                var vXmlHttpLogin = new XMLHttpRequest();
                goiAPILogin (vXmlHttpLogin, vFormData);

                // B4: Xử lý kết quả trả về
                vXmlHttpLogin.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        xuLyKetQuaTraVe(vXmlHttpLogin);
                    }
                }

            }

        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        // Hàm lấy dữ liệu từ form và đẩy vào object paramFormData
        function layDuLieu(paramFormData) {
            var vInputEmailElement = document.getElementById("input-email");
            var vInputPasswordElement = document.getElementById("input-password");
            paramFormData.email = vInputEmailElement.value;
            paramFormData.password = vInputPasswordElement.value;

        }
        
        // Hàm kiểm tra dữ liệu
        function kiemTraDuLieu(paramFormData) {
            if (!validateEmail(paramFormData.email)){
                alert ("Bạn chưa nhập email hoặc email không đúng định dạng");
                return false;
            }

            // Kiểm tra chiều dài mật khẩu, phải lớn hơn hoặc bằng 6 ký tự
            if (paramFormData.password.length <6){
                alert ("Mật khẩu quá ngắn");
                return false;
            }
            return true;
        }
        
        // Hàm gọi API:
        function goiAPILogin (paramXmlHttpLogin, paramFormData){
            const vParams = new URLSearchParams(paramFormData);
            var vUrl = gBASE_URL + "?" + vParams.toString();
            console.log(vUrl);
            // create a request            
            paramXmlHttpLogin.open("GET", vUrl, true);
            paramXmlHttpLogin.send();
        }

        // Hàm xử lý kết quả trả về
        function xuLyKetQuaTraVe(paramXmlHttpLogin){
            var vLoginInfo = paramXmlHttpLogin.responseText;
            console.log(vLoginInfo);
        }
        // Hàm kiểm tra email
        function validateEmail(paramEmail) {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(paramEmail)) {
                return (true)
            }
            return (false)
        }
    </script>

</body>

</html>